unit ADKMemo;

interface

uses
 Windows,Classes,SysUtils,
 ADKData,ADKGUI;

procedure ClearMemo;
procedure MemoAdd(s:string);
procedure RenderMemo(dc:HDC);

implementation

uses
 ADKRender, ADKDepth, ADKScreens;

var
 lines:TStringList;

procedure ClearMemo;
begin
 lines.clear;
end;

procedure MemoAdd(s:string);
begin
 lines.add(s);
end;

procedure RenderMemo(dc:HDC);
var
 y:integer;
 i:integer;
 s:string;
 ts:TSize;
begin
 // blabla dans la zone de chat...
 SetBkMode(dc,TRANSPARENT);
 SetTextColor(dc,$00FF00);
 y:=ADKScreen.Height-40;
 for i:=lines.count-1 downto 0 do begin
  s:=lines[i];
  TextOut(dc,2,y,@s[1],length(s));
  GetTextExtentPoint(dc,@s[1],Length(s),ts);
  dec(y,ts.cy);
 end;
end;

initialization
 lines:=TStringList.Create;
finalization
 lines.free;
end.
