unit IsoMap1;

{
 projet ADK-ISO (c)2002-2003 Paul TOTH <tothpaul@free.fr>

 http://www.web-synergy.net/naug-land/

}

interface
{-define FPS}
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, MapFrames, ExtCtrls, ComCtrls, ToolWin, ImgList, Menus,
  StdActns, ActnList, StdCtrls, ADKImages, ImageTrees, DXError, EditMaps,
  CheckLst,ShellAPI;

type
  TCopyPast=record
   Index,x,y:integer;
  end;

  TMainForm = class(TForm)
    ActionList1: TActionList;
    acShowGrid: TAction;
    acResetFPS: TAction;
    acFileOpen: TFileOpen;
    FileExit1: TFileExit;
    acImportMA2: TFileOpen;
    acNew: TAction;
    acShowText: TAction;
    acShowCurrent: TAction;
    acShowActive: TAction;
    FileSave: TAction;
    FileSaveAs1: TFileSaveAs;
    acShowSelection: TAction;
    acShowObjects: TAction;
    FileSaveAs2: TFileSaveAs;
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Nouveau1: TMenuItem;
    Ouvrir1: TMenuItem;
    Enregistrer1: TMenuItem;
    Enregistrersous1: TMenuItem;
    ReOpen: TMenuItem;
    Enregistrerlesimagessous1: TMenuItem;
    N1: TMenuItem;
    Importer1: TMenuItem;
    N3: TMenuItem;
    Quitter1: TMenuItem;
    Edition1: TMenuItem;
    miMapProps: TMenuItem;
    Afficher1: TMenuItem;
    ShowGrid: TMenuItem;
    Afficherlesobjets1: TMenuItem;
    Minivue1: TMenuItem;
    N4: TMenuItem;
    Affichertout1: TMenuItem;
    Cachertout1: TMenuItem;
    N2: TMenuItem;
    AboutIsoMapper1: TMenuItem;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet3: TTabSheet;
    MapFrame1: TMapFrame;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton3: TToolButton;
    ToolButton7: TToolButton;
    ToolButton4: TToolButton;
    ToolButton2: TToolButton;
    Label1: TLabel;
    StatusBar1: TStatusBar;
    ImageTree1: TImageTree;
    Splitter1: TSplitter;
    ToolButton14: TToolButton;
    acSaveAll: TAction;
    BibliothquedimageLBA1: TMenuItem;
    CarteADKMA21: TMenuItem;
    acImportLBA: TFileOpen;
    lbBack: TListBox;
    ToolBar2: TToolBar;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    acListUp: TAction;
    acListDown: TAction;
    ToolButton15: TToolButton;
    ToolButton16: TToolButton;
    acListDel: TAction;
    acShowMiniMap: TAction;
    acBackground: TAction;
    acGrid: TAction;
    acObjects: TAction;
    acShowBack: TAction;
    Fond1: TMenuItem;
    Dslectionner1: TMenuItem;
    Panel1: TPanel;
    TabControl1: TTabControl;
    Terrain1: TMenuItem;
    N6: TMenuItem;
    outslectionner1: TMenuItem;
    Inverserslection1: TMenuItem;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    acImgProperties: TAction;
    TabSheet2: TTabSheet;
    clbSwitches: TCheckListBox;
    ToolBar3: TToolBar;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    acAddSwitch: TAction;
    acDelSwitch: TAction;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    N5: TMenuItem;
    Couleurdufond1: TMenuItem;
    ColorSelect1: TColorSelect;
    N7: TMenuItem;
    Copier1: TMenuItem;
    Coller1: TMenuItem;
    cbForeGroundSelect: TToolButton;
    Fusionnerunelibgraphique1: TMenuItem;
    acMergeLib: TFileOpen;
    ActionButtons: TToolBar;
    ImageList1: TImageList;
    ToolButton17: TToolButton;
    ToolButton18: TToolButton;
    ToolButton19: TToolButton;
    ActionList2: TActionList;
    acTeleport: TAction;
    acReception: TAction;
    acFlipper: TAction;
    TabSheet4: TTabSheet;
    lbTeleport: TListBox;
    Label2: TLabel;
    lbReception: TListBox;
    Label3: TLabel;
    Splitter2: TSplitter;
    Panel2: TPanel;
    Panel3: TPanel;
    Label4: TLabel;
    lbFlipper: TListBox;
    Splitter3: TSplitter;
    CreeperTimer: TTimer;
    Panel4: TPanel;
    Label5: TLabel;
    ListBox1: TListBox;
    Splitter4: TSplitter;
    procedure FormCreate(Sender: TObject);
    procedure acSaveAllExecute(Sender: TObject);
    procedure acImportLBAAccept(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure acImportMA2Accept(Sender: TObject);
    procedure MapFrame1PaintBox1Paint(Sender: TObject);
    procedure MapFrame1PaintBox1MouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure MapFrame1PaintBox1MouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure acFileOpenAccept(Sender: TObject);
    procedure lbBackDblClick(Sender: TObject);
    procedure acListUpExecute(Sender: TObject);
    procedure acListDownExecute(Sender: TObject);
    procedure lbBackDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure lbBackDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure lbBackClick(Sender: TObject);
    procedure acListDelExecute(Sender: TObject);
    procedure FileSaveExecute(Sender: TObject);
    procedure MapFrame1PaintBox1DragOver(Sender, Source: TObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure MapFrame1PaintBox1DragDrop(Sender, Source: TObject; X,
      Y: Integer);
    procedure lbBackData(Control: TWinControl; Index: Integer;
      var Data: String);
    procedure acShowMiniMapExecute(Sender: TObject);
    procedure acModesExecute(Sender: TObject);
    procedure miMapPropsClick(Sender: TObject);
    procedure acShowBackExecute(Sender: TObject);
    procedure Dslectionner1Click(Sender: TObject);
    procedure TabControl1Change(Sender: TObject);
    procedure Inverserslection1Click(Sender: TObject);
    procedure outslectionner1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FileSaveAs1Accept(Sender: TObject);
    procedure acImgPropertiesExecute(Sender: TObject);
    procedure acAddSwitchExecute(Sender: TObject);
    procedure clbSwitchesDblClick(Sender: TObject);
    procedure lbBackMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ColorSelect1Accept(Sender: TObject);
    procedure Copier1Click(Sender: TObject);
    procedure Coller1Click(Sender: TObject);
    procedure acNewExecute(Sender: TObject);
    procedure clbSwitchesData(Control: TWinControl; Index: Integer;
      var Data: String);
    procedure clbSwitchesClick(Sender: TObject);
    procedure ToolButton13Click(Sender: TObject);
    procedure acTeleportExecute(Sender: TObject);
    procedure lbTeleportDblClick(Sender: TObject);
    procedure acReceptionExecute(Sender: TObject);
    procedure lbTeleportClick(Sender: TObject);
    procedure lbReceptionClick(Sender: TObject);
    procedure acFlipperExecute(Sender: TObject);
    procedure lbFlipperClick(Sender: TObject);
    procedure lbFlipperDblClick(Sender: TObject);
    procedure CreeperTimerTimer(Sender: TObject);
    procedure acMergeLibAccept(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    fSelected:TEditImage;
  {$ifdef FPS}
    fMegaFrames:integer;
    fStartTime:Cardinal;
  {$endif}
    fMapName:string;
    fBackground:TColor;
    fClipBoard:TList;
    fCopyX,fCopyY:integer;
    fCopyIndex:integer;
    penYellow,penLime,penRed:THandle;
    procedure OnHint(Sender:TObject);
    procedure OnException(Sender:TObject; E:Exception);
    procedure ObstacleClick(Sender:TObject);
    procedure SetSelected(Value:TEditImage);
    procedure ClearSelection;
    procedure MeasureColorItem(Sender: TObject; ACanvas: TCanvas; var Width, Height: Integer);
    procedure DrawColorItem(Sender: TObject; ACanvas: TCanvas; ARect: TRect; Selected: Boolean);
    procedure LoadMap(AMapName:string);
    procedure WMDropFiles(Var Msg:TMessage); message WM_DROPFILES;
  public
    { Public declarations }
    property Selected:TEditImage read fSelected write SetSelected;
  end;

var
  MainForm: TMainForm;

implementation

uses ImportBitmaps, ADKUtils, CommonData, ImportLBAs, ImportMA2s,
  ImageProperties, MiniViews, MapProperties, ADKMaps, ADKScreens, Teleports,
  FlipperProperites;

{$R *.dfm}

procedure ClearObjectList(List:TList);
var
 i:integer;
begin
 for i:=0 to List.Count-1 do TObject(List[i]).Free;
 List.Clear;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
 m:TMenuItem;
 o:TObstacle;
begin
 fClipBoard:=TList.Create;
 Application.OnHint:=OnHint;
 Application.OnException:=OnException;
 acImportLBA.Dialog.Filter:=LBAFilter+'|'+ALLFilter;
 acImportMA2.Dialog.Filter:=MA2Filter+'|'+ALLFilter;
 acFileOpen.Dialog.Filter :=ADKFilter+'|'+ALLFilter;
 acMergeLib.Dialog.Filter :=IMLFilter+'|'+ALLFilter;
 LoadDialog(acImportLBA.Dialog);
 LoadDialog(acImportMA2.Dialog);
 LoadDialog(acFileOpen.Dialog);
 LoadDialog(acMergeLib.Dialog);
 for o:=low(TObstacle) to High(TObstacle) do begin
  m:=NewItem(ObstacleNames[o],0,False, True, ObstacleClick,0,'');
//  m.OnMeasureItem:=MeasureColorItem;
  m.OnDrawItem:=DrawColorItem;
  m.Tag:=ord(o);
  Terrain1.Add(m);
 end;
 penYellow:=CreatePen(PS_DOT,1,clYellow);
 penLime:=CreatePen(PS_DOT,1,clLime);
 penRed:=CreatePen(PS_SOLID,1,clRed);
 DragAcceptFiles(Handle,True);
end;

procedure TMainForm.WMDropFiles(Var Msg:TMessage);
Const
 MaxLen=512;
var
 count:integer;
 s,e:string;
 i:integer;
 l:integer;
 m:TMenuItem;
begin
 count:=DragQueryFile(Msg.wParam,uint(-1),nil,0);
 for i:=0 to count-1 do begin
  SetLength(s,MaxLen);
  l:=DragQueryFile(Msg.wParam,i,pchar(s),length(s));
  Setlength(s,l);
  e:=uppercase(ExtractFileExt(s));
  if e='.IML' then ImageTree1.OpenLib(s) else
  if e='.ADK' then LoadMap(s);
 end;
 DragFinish(Msg.wParam);
end;

procedure TMainForm.MeasureColorItem(Sender: TObject; ACanvas: TCanvas; var Width, Height: Integer);
begin
 inc(Width,24);
end;

procedure TMainForm.DrawColorItem(Sender: TObject; ACanvas: TCanvas; ARect: TRect; Selected: Boolean);
const
 Walkable  =[TobsStandard..TobsSand];
 SeeThrough=[TobsNone,TobsStandard..TobsLittleWall,TobsSet,TobsGrille, TobsHerse];
var
 o:TObstacle;
 s:string;
begin
 o:=TObstacle(TMenuItem(Sender).Tag);
 with ACanvas do begin
  TextRect(ARect,ARect.Left+24,ARect.Top+2,ObstacleNames[o]);
  Brush.Color:=MiniViews.Colors[o];
  Rectangle(ARect.Left+2,ARect.Top+3,ARect.Left+20,ARect.Bottom-3);
  Brush.Color:=clGray;
  if o in Walkable   then TextOut(ARect.Right-22,ARect.Top+2,'M');
  if o in SeeThrough then TextOut(ARect.Right-10,ARect.Top+2,'V');
 end;
end;

procedure TMainForm.OnException(Sender:TObject; E:Exception);
begin
//- if E is EDXError then CloseDX;
 Application.ShowException(E);
end;

procedure TMainForm.OnHint(Sender:TObject);
begin
 StatusBar1.Panels[2].Text:=getLongHint(Application.Hint);
end;

procedure TMainForm.ObstacleClick(Sender:TObject);
begin
 MapFrame1.SetObstacle(TObstacle(TComponent(Sender).Tag));
 MiniView.Redraw;
end;

procedure TMainForm.SetSelected(Value:TEditImage);
begin
// if fSelected<>nil then fSelected.Mask:=0;
 fSelected:=Value;
 if fSelected<>nil then fSelected.Mask:=$ff0000;
 if (ImageEditor<>nil) and ImageEditor.Visible then ImageEditor.Image:=fSelected;
end;

procedure TMainForm.ClearSelection;
var
 i:integer;
begin
 with MapFrame1.EditMap do begin
  for i:=0 to ImageCount-1 do Images[i].Mask:=0;
  for i:=0 to ItemCount-1 do Items[i].Mask:=0;
 end;
end;

procedure TMainForm.acSaveAllExecute(Sender: TObject);
begin
 ImageTree1.acSaveTree.Execute;
end;

procedure TMainForm.acImportLBAAccept(Sender: TObject);
begin
 LBAImport(OpenFileName(acImportLBA.Dialog),ImageTree1);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
 SaveDialog(acImportLBA.Dialog);
 SaveDialog(acImportMA2.Dialog);
 SaveDialog(acFileOpen.Dialog);
 SaveDialog(acMergeLib.Dialog);
 ClearObjectList(fClipBoard);
 fClipBoard.Free;
end;

procedure TMainForm.acImportMA2Accept(Sender: TObject);
begin
 fMapName:=MA2Import(OpenFileName(acImportMA2.Dialog));
 if fMapName='' then exit;
 MapFrame1.LoadFromFile(fMapName);
 lbBack.Count:=MapFrame1.EditMap.ImageCount+MapFrame1.EditMap.ItemCount;
end;

procedure TMainForm.MapFrame1PaintBox1Paint(Sender: TObject);
var
 x,y:integer;
 size:TPoint;
 dc:HDC;
 pen,oldpen:THandle;
 org:TPoint;
{$IFDEF FPS}
 StartDraw:Cardinal;
 i:integer;
{$ENDIF}
begin
 if ADKScreen=nil then exit;
{$IFDEF FPS}
 StartDraw:=GetTickCount;
{$ENDIF}
 MapFrame1.EditMap.ImageLib:=ImageTree1.ImageLib;
 //ClearDX(fBackground);
 ADKScreen.Clear(fBackground);
 MapFrame1.PaintBox1Paint(Sender);
 if (MapFrame1.Mode<>mmGrid)and(fSelected<>nil) then begin
  size:=ImageTree1.ImageLib.Size[fSelected.Data.Index];
  x:=fSelected.Data.Position.x+MapFrame1.ScrollX;
  y:=fSelected.Data.Position.y+MapFrame1.ScrollY;

  dc:=ADKScreen.GetDC;//GetDirectDC;
  try
   if ifForeground in fSelected.Data.Flags then pen:=penLime else pen:=penYellow;
   oldpen:=SelectObject(dc,pen);
   SetBkMode(dc,TRANSPARENT);
   MoveToEx(dc,x,y,nil);
   LineTo(dc,x+size.X,y);
   LineTo(dc,x+size.x,y+size.y);
   LineTo(dc,x,y+size.y);
   LineTo(dc,x,y);
   if ifForeground in fSelected.Data.Flags then begin
    inc(y,fSelected.Data.BaseLine);
    MoveToEx(dc,0,y,nil);
    LineTo(dc,MapFrame1.Width,y);
    dec(y,fSelected.Data.BaseLine);
   end;
   SelectObject(dc,oldpen);
   oldpen:=SelectObject(dc,penRed);
   org:=ImageTree1.ImageOrg(fSelected);
   inc(x,org.x);
   inc(y,org.y);
   MoveToEx(dc,x-4,y,nil); LineTo(dc,x+4,y);
   MoveToEx(dc,x,y-4,nil); LineTo(dc,x,y+4);
   SelectObject(dc,oldpen);
  finally
   //ReleaseDirectDC;
   ADKScreen.ReleaseDC;
  end;

 end;
 //SwapDX;
 ADKScreen.Flip;
{$IFDEF FPS}
 inc(fMegaFrames,1000);
 if fStartTime=0 then fStartTime:=GetTickCount;
 i:=GetTickCount;
 StatusBar1.Panels[0].Text:=IntToStr(fMegaFrames div (i-fStartTime+1))+' fps';
 StatusBar1.Panels[1].Text:=IntToStr(i-StartDraw)+' ms/frame';
 Application.ProcessMessages;
 if not (Application.Terminated) then InvalidateRect(MapFrame1.Handle,nil,False);
{$ENDIF}
end;

procedure TMainForm.MapFrame1PaintBox1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
 i:integer;
begin
 FileSave.Enabled:=True;
 MapFrame1.PaintBox1MouseDown(Sender, Button, Shift, X, Y);
 if (Button=mbLeft) then begin
  if ssCtrl in Shift then begin
   MapFrame1.SetSpritePos(x,y);
  end else
  if (MapFrame1.Mode=mmBack) then begin
   lbBack.Items.BeginUpdate;
   try
    if Shift * [ssShift, ssCtrl]=[] then begin
     ClearSelection;
     lbBack.ClearSelection;
    end;
    i:=MapFrame1.GetItemXY(cbForegroundSelect.Down);
    if i>=0 then lbBack.Selected[i]:=True;
    lbBack.ItemIndex:=i;
    lbBackClick(nil);
   finally
    lbBack.Items.EndUpdate;
   end;
   if i>=0 then exit;
  end;
  MapFrame1.Invalidate;
 end;
end;

procedure TMainForm.MapFrame1PaintBox1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
 p:TPoint;
 s:string;
begin
 MapFrame1.PaintBox1MouseMove(Sender, Shift, X, Y);
 if ssRight in Shift then MiniView.Invalidate;
 p:=MapFrame1.ScreenToGrid(x,y);
 if (p.x>=0)and(p.x<MapFrame1.EditMap.Width)
 and(p.y>=0)and(p.y<MapFrame1.EditMap.Height) then
  s:=ObstacleNames[MapFrame1.EditMap.Cells[p.x,p.y].Obstacle]
 else
  s:='out';
 StatusBar1.Panels[0].Text:=Format(
  '(%d,%d) %s',
  [p.x,p.y,s]
 );
end;

procedure TMainForm.acFileOpenAccept(Sender: TObject);
begin
 LoadMap(OpenFileName(acFileOpen.Dialog));
end;

procedure TMainForm.LoadMap(AMapName:string);
var
 i,c:integer;
 b:boolean;
begin
 if FileSave.Enabled then begin
  case MessageDlg('Voulez-vous enregistrer les modifications de cette carte ?',mtConfirmation,[mbYes,mbNo,mbCancel],0) of
   mrYes    : begin FileSave.Execute; if FileSave.Enabled then exit; end; 
   mrCancel : exit;
  end;
 end;

 Selected:=nil;
 if ImageTree1.ImageLib.FileName='' then begin
  ShowMessage('Vous devez ouvrir une bibliothque d''images');
  exit;
 end;
 fMapName:=AMapName;
 MapFrame1.LoadFromFile(fMapName);

 b:=False;
 for i:=MapFrame1.EditMap.ImageCount-1 downto 0 do begin
  if ImageTree1.ImageLib.Deleted(MapFrame1.EditMap.Images[i].Data.Index) then begin
   MapFrame1.Remove(i);
   b:=True;
  end;
 end;
 c:=MapFrame1.EditMap.ImageCount;
 for i:=MapFrame1.EditMap.ItemCount-1 downto 0 do begin
  if ImageTree1.ImageLib.Deleted(MapFrame1.EditMap.Items[i].Data.Index) then begin
   MapFrame1.Remove(i+c);
   b:=True;
  end;
 end;
 if b then ShowMessage('Cette carte contenait des images qui ont t supprimes');

 lbBack.Count:=MapFrame1.EditMap.ImageCount+MapFrame1.EditMap.ItemCount;
 //clbSwitches.Count:=MapFrame1.EditMap.FlagNames.Count;
 with MapFrame1.EditMap do begin
  clbSwitches.Items.Assign(FlagNames);
  for i:=0 to FlagNames.Count-1 do begin
   clbSwitches.Checked[i]:=(Flags and FlagMask(i))<>0;
  end;
 end;
 MiniView.ResetMap;
 MapFrame1.Invalidate;
end;

procedure TMainForm.lbBackDblClick(Sender: TObject);
var
 i,count:integer;
begin
 i:=lbBack.ItemIndex;
 if i<0 then exit;
 count:=MapFrame1.EditMap.ImageCount;
 if i<Count then
  Selected:=MapFrame1.EditMap.Images[i]
 else
  Selected:=MapFrame1.EditMap.Items[i-Count];
 EditImage(fSelected);
end;

procedure TMainForm.acListUpExecute(Sender: TObject);
var
 i,j:integer;
begin
 i:=lbBack.ItemIndex;
 if i<1 then exit;
 if i>=MapFrame1.EditMap.ImageCount then exit;
 j:=i-1;
 while (j>0) and (not MapFrame1.EditMap.Intersect(i,j)) do dec(j);
 MapFrame1.Exchange(i,j);
 lbBack.ItemIndex:=j;
 lbBackClick(Self);
end;

procedure TMainForm.acListDownExecute(Sender: TObject);
var
 i,j,c:integer;
begin
 i:=lbBack.ItemIndex;
 if i<0 then exit;
 c:=MapFrame1.EditMap.ImageCount;
 if i>=c-1 then exit;
 j:=i+1;
 while (j<c) and (not MapFrame1.EditMap.Intersect(i,j)) do inc(j);
 MapFrame1.Exchange(i,j);
 lbBack.ItemIndex:=j;
 lbBackClick(Self);
end;

procedure TMainForm.lbBackDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
var
 i:integer;
begin
 Accept:=(Source=lbBack);
 if Accept then begin
  i:=lbBack.ItemAtPos(Point(x,y),False);
  Accept:=(i>=0)and(i<>lbBack.ItemIndex);
 end;
end;

procedure TMainForm.lbBackDragDrop(Sender, Source: TObject; X, Y: Integer);
var
 i:integer;
begin
 i:=lbBack.ItemAtPos(Point(x,y),False);
 MapFrame1.Move(lbBack.ItemIndex,i);
 lbBack.Invalidate;
end;

procedure TMainForm.lbBackClick(Sender: TObject);
var
 i,count:integer;
 img:TEditImage;
begin
 count:=MapFrame1.EditMap.ImageCount;
// mise  jour des masque (images rouges)
 for i:=0 to count-1 do begin
  if lbBack.Selected[i] then
   MapFrame1.EditMap.Images[i].Mask:=$ff0000
  else
   MapFrame1.EditMap.Images[i].Mask:=0;
 end;
// idem pour les avant-plans
 for i:=0 to MapFrame1.EditMap.ItemCount-1 do begin
  if lbBack.Selected[i+count] then
   MapFrame1.EditMap.Items[i].Mask:=$ff0000
  else
   MapFrame1.EditMap.Items[i].Mask:=0;
 end;
 i:=lbBack.ItemIndex;
 if i<0 then begin
  Selected:=nil;
 end else begin
  count:=MapFrame1.EditMap.ImageCount;
  if i<count then
   img:=MapFrame1.EditMap.Images[i]
  else
   img:=MapFrame1.EditMap.Items[i-count];
  ImageTree1.Select(img.Data.Index);
  MapFrame1.ShowImage(img);
  {if MapFrame1.Mode<>mmGrid then} Selected:=img;
 end;
 MapFrame1.Invalidate;
 EXIT; //---------------------------
 i:=lbBack.ItemIndex;
 if i<0 then begin
  Selected:=nil;
  exit;
 end;
 count:=MapFrame1.EditMap.ImageCount;
 if i<count then
  img:=MapFrame1.EditMap.Images[i]
 else
  img:=MapFrame1.EditMap.Items[i-count];
(*
 if (lbBack.SelCount>0)and(img.Mask<>0) then begin
  img.Mask:=0;
  lbBack.Selected[i]:=False;
  if img=fSelected then Selected:=nil;
  MapFrame1.Invalidate;
  exit;
 end;
*)
// if lbBack.SelCount=1 then ClearSelection;
 ImageTree1.Select(img.Data.Index);
 MapFrame1.ShowImage(img);
 if MapFrame1.Mode<>mmGrid then Selected:=img;
 MapFrame1.Invalidate;
end;

procedure TMainForm.acListDelExecute(Sender: TObject);
var
 i:integer;
begin
 i:=lbBack.ItemIndex;
 if i<0 then exit;
 Selected:=nil;
 MapFrame1.Remove(i);
 lbBack.Count:=lbBack.Count-1;
 lbBack.ItemIndex:=-1;//i;
 //lbBackClick(Self);
end;

procedure TMainForm.FileSaveExecute(Sender: TObject);
begin
 if fMapName='' then
  FileSaveAs1.Execute
 else begin
  MapFrame1.EditMap.SaveToFile(fMapName);
  FileSave.Enabled:=False;
 end;
end;

procedure TMainForm.MapFrame1PaintBox1DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
 Accept:=(Source=ImageTree1.TreeView)and(ImageTree1.TreeView.Selected.Data<>nil);
end;

procedure TMainForm.MapFrame1PaintBox1DragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
 img:PImageDef;
 ox,oy,u,v:integer;
 o:TPoint;
 ei:TEditImage;
 i:integer;
begin
 FileSave.Enabled:=True;
 img:=ImageTree1.TreeView.Selected.Data;

 o:=MapFrame1.EditMap.Origin;
 ox:=x-MapFrame1.ScrollX-o.x;
 oy:=y-MapFrame1.ScrollY-o.y;
 u:=(2*oy+ox) div 96;
 v:=(2*oy-ox) div 96;
 ox:=48*(u-v)-img.Origin.X+o.x;
 oy:=24*(u+v)-img.Origin.Y+o.y+24;

 ei:=MapFrame1.EditMap.AddImage(ox,oy,img.Index,img.Origin.y,[]);
 i:=MapFrame1.EditMap.ImageCount-1; // index de l'image
 if cbForeGroundSelect.Down then begin
  ei.SetForeground(True);
  inc(i,MapFrame1.EditMap.ItemCount-1); // index de l'image
 end;
 ClearSelection;
// Selected:=ei;
 lbBack.Count:=lbBack.Count+1;
 lbBack.ItemIndex:=i;
 lbBackClick(nil);

 MapFrame1.Invalidate;
end;

procedure TMainForm.lbBackData(Control: TWinControl; Index: Integer;
  var Data: String);
var
 img:TEditImage;
begin
 if Index<MapFrame1.EditMap.ImageCount then begin
  img:=MapFrame1.EditMap.Images[Index];
  Data:=ImageTree1.ImageName(img);
 end else begin
  dec(Index,MapFrame1.EditMap.ImageCount);
  if Index>=MapFrame1.EditMap.ItemCount then begin
   Data:='';
  end else begin
   img:=MapFrame1.EditMap.Items[Index];
   Data:='['+ImageTree1.ImageName(img)+']';
  end;
 end;
end;

procedure TMainForm.acShowMiniMapExecute(Sender: TObject);
var
 b:boolean;
begin
 MiniView.ResetMap;
 b:=not acShowMiniMap.Checked;
 acShowMiniMap.Checked:=b;
 MiniView.Visible:=b;
end;

procedure TMainForm.acModesExecute(Sender: TObject);
begin
 MapFrame1.Mode:=TMapMode(TComponent(Sender).Tag);
 Selected:=nil;
 MapFrame1.Invalidate;
end;

procedure TMainForm.miMapPropsClick(Sender: TObject);
begin
 EditMapProps(MapFrame1.Handle, MapFrame1.EditMap);
 FileSave.Enabled:=True;
end;

procedure TMainForm.acShowBackExecute(Sender: TObject);
begin
 with TAction(Sender) do begin
  Checked:=not Checked;
  if Checked then
   MapFrame1.Options:=MapFrame1.Options+TShowOptions(byte(tag))
  else
   MapFrame1.Options:=MapFrame1.Options-TShowOptions(byte(tag));
 end;
 MapFrame1.Invalidate;
end;

procedure TMainForm.Dslectionner1Click(Sender: TObject);
begin
 MapFrame1.UnSelectAll;
end;

procedure TMainForm.TabControl1Change(Sender: TObject);
begin
 MapFrame1.Mode:=TMapMode(TabControl1.TabIndex);
// if fSelected<>nil then fSelected.Mask:=0;
 ActionButtons.Visible:=MapFrame1.Mode=mmGrid;
 MapFrame1.Invalidate;
end;

procedure TMainForm.Inverserslection1Click(Sender: TObject);
begin
 MapFrame1.InvertSelection;
end;

procedure TMainForm.outslectionner1Click(Sender: TObject);
begin
 MapFrame1.SelectAll;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
 if ImageTree1.acSaveTree.Enabled then begin
  case MessageDlg('Voulez-vous enregistrer les modifications dans l''arborescence d''images ?',mtConfirmation,[mbYes,mbNo,mbCancel],0) of
   mrYes    : CanClose:=ImageTree1.acSaveTree.Execute;
   mrCancel : CanClose:=False;
  end;
 end;
 if FileSave.Enabled then begin
  case MessageDlg('Voulez-vous enregistrer les modifications de cette carte ?',mtConfirmation,[mbYes,mbNo,mbCancel],0) of
   mrYes    : begin FileSave.Execute; CanClose:=FileSave.Enabled=False; end;
   mrCancel : CanClose:=False;
  end;
 end;
end;

procedure TMainForm.FileSaveAs1Accept(Sender: TObject);
begin
 fMapName:=OpenFileName(FileSaveAs1.Dialog);
 MapFrame1.EditMap.SaveToFile(fMapName);
 FileSave.Enabled:=False;
end;

procedure TMainForm.acImgPropertiesExecute(Sender: TObject);
begin
 if (fSelected<>nil) then EditImage(fSelected);
end;

procedure TMainForm.acAddSwitchExecute(Sender: TObject);
var
 s:string;
begin
 FileSave.Enabled:=True;
 s:=InputBox('Ajouter','Commutateur','');
 if s<>'' then begin//clbSwitches.Items.Add(s);
  MapFrame1.EditMap.AddFlag(s);
  clbSwitches.Items.Add(s);
 end;
end;

procedure TMainForm.clbSwitchesDblClick(Sender: TObject);
var
 i:integer;
 s:string;
begin
 FileSave.Enabled:=True;
 i:=clbSwitches.ItemIndex;
 if i<0 then exit;
 s:=MapFrame1.EditMap.FlagNames[i];
 s:=InputBox('Modifier','Commutateur',s);
 if s<>'' then begin
  MapFrame1.EditMap.FlagNames[i]:=s;
  clbSwitches.Items[i]:=s;
 end;
end;

procedure TMainForm.lbBackMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if Shift * [ssShift,ssCtrl]=[] then ClearSelection;
end;

procedure TMainForm.ColorSelect1Accept(Sender: TObject);
begin
 fBackGround:=ColorSelect1.Dialog.Color;
 fBackGround:=fBackGround and $00ff00
             +fBackGround shr 16
             +fBackGround shl 16;
 MapFrame1.Invalidate;
end;

procedure TMainForm.Copier1Click(Sender: TObject);
var
 i,count:integer;
 img:TEditImage;
begin
 count:=lbBack.SelCount;
 if count=0 then exit;

 ClearObjectList(fClipboard);
 fCopyX:=MapFrame1.ScrollX;
 fCopyY:=MapFrame1.ScrollY;
 fCopyIndex:=-1;

 count:=MapFrame1.EditMap.ImageCount;
 for i:=0 to Count-1 do
  if lbBack.Selected[i] then begin
   img:=MapFrame1.EditMap.Images[i];
   if img=fSelected then fCopyIndex:=fClipBoard.Count;
   fClipBoard.Add(img.Copy);
  end;
 for i:=0 to MapFrame1.EditMap.ItemCount-1 do
  if lbBack.Selected[count+i] then begin
   img:=MapFrame1.EditMap.Items[i];
   if img=fSelected then fCopyIndex:=fClipBoard.Count;
   fClipBoard.Add(img.Copy);
  end;
end;

procedure TMainForm.Coller1Click(Sender: TObject);
var
 dx,dy,i,j,k:integer;
 count:integer;
begin
 with MapFrame1.EditMap do begin
  for i:=0 to ImageCount-1 do Images[i].Mask:=0;
  for i:=0 to ItemCount-1 do Items[i].Mask:=0;
 end;
 dx:=fCopyX-MapFrame1.ScrollX;
 dy:=fCopyY-MapFrame1.ScrollY;
{
 fCopyX:=MapFrame1.ScrollX;
 fCopyY:=MapFrame1.ScrollY;
 if (dx=0)and(dy=0) then begin
  dx:=10;
  dy:=10;
  MapFrame1.ScrollX:=fCopyX+10;
  MapFrame1.ScrollY:=fCopyY+10;
 end;
}
 j:=-1;
 for i:=0 to fClipBoard.Count-1 do begin
  k:=TEditImage(fClipBoard[i]).Copy.Past(MapFrame1.EditMap,dx,dy);
  if i=fCopyIndex then j:=k;
 end;
 lbBack.Count:=lbBack.Count+fClipBoard.Count;
 lbBack.ItemIndex:=j;
 count:=MapFrame1.EditMap.ImageCount;
 if j>=count then
  fSelected:=MapFrame1.EditMap.Items[j-count]
 else
 if j>=0 then
  fSelected:=MapFrame1.EditMap.Images[j]
 else
  fSelected:=nil;
// lbBackClick(nil);
 MapFrame1.Invalidate;
end;

procedure TMainForm.acNewExecute(Sender: TObject);
begin
 if MessageDlg('Voulez-vous effacer la carte en cours ?',mtConfirmation,[mbYes,mbNo],0)=mrYes then begin
  MapFrame1.EditMap.Clear;
  MapFrame1.Invalidate;
  clbSwitches.Clear;
  fMapName:='';
 end;
end;

procedure TMainForm.clbSwitchesData(Control: TWinControl; Index: Integer;
  var Data: String);
begin
 Data:=MapFrame1.EditMap.FlagNames[Index];
end;

procedure TMainForm.clbSwitchesClick(Sender: TObject);
var
 i,m,f:integer;
begin
 i:=clbSwitches.ItemIndex;
 if i<0 then exit;
 m:=MapFrame1.EditMap.FlagMask(i);
 f:=MapFrame1.EditMap.Flags;
 if clbSwitches.Checked[i] then f:=f or m else f:=f and (not m);
 MapFrame1.EditMap.Flags:=f;
 MapFrame1.Invalidate;
end;

procedure TMainForm.ToolButton13Click(Sender: TObject);
begin
 MapFrame1.SetSpritePos(MapFrame1.Width div 2,MapFrame1.Height div 2);
 MapFrame1.EditMap.ShowSprite:=ToolButton13.Down;
 CreeperTimer.Enabled:=ToolButton13.Down;
 MapFrame1.Invalidate;
end;

procedure TMainForm.acTeleportExecute(Sender: TObject);
var
 t:TTeleportation;
begin
 if not MapFrame1.GetSelectionRect then begin
  ShowMessage('Vous devez slectionner une zone rectangulaire unique pour cette fonction.');
  exit;
 end;
 if TeleportProperties.Execute then begin
  t:=TeleportProperties.GetTeleportation;
  t.Rect:=MapFrame1.Selection;
  lbTeleport.Items.AddObject(TeleportProperties.cbTarget.Text,t)
 end;
end;

procedure TMainForm.lbTeleportClick(Sender: TObject);
var
 i:integer;
 t:TTeleportation;
begin
 i:=lbTeleport.ItemIndex;
 if i<0 then exit;
 TabControl1.TabIndex:=1;
 Tabcontrol1Change(Self);
 t:=lbTeleport.Items.Objects[i] as TTeleportation;
 MapFrame1.SelectRect(t.Rect);
end;

procedure TMainForm.lbTeleportDblClick(Sender: TObject);
var
 i:integer;
 t:TTeleportation;
begin
 i:=lbTeleport.ItemIndex;
 if i<0 then exit;
 t:=lbTeleport.Items.Objects[i] as TTeleportation;
 TeleportProperties.Edit(t);
end;

procedure TMainForm.acReceptionExecute(Sender: TObject);
var
 s:string;
 r:TReception;
begin
 if not MapFrame1.GetSelectionRect then begin
  ShowMessage('Vous devez slectionner une zone rectangulaire unique pour cette fonction.');
  exit;
 end;
 s:='';
 if InputQuery('Rception','Nom de la zone',s) then begin
  r:=TReception.Create;
  r.Name:=s;
  r.Rect:=MapFrame1.Selection;
  lbReception.Items.AddObject(s,r)
 end;
end;

procedure TMainForm.lbReceptionClick(Sender: TObject);
var
 i:integer;
 r:TReception;
begin
 i:=lbReception.ItemIndex;
 if i<0 then exit;
 TabControl1.TabIndex:=1;
 Tabcontrol1Change(Self);
 r:=lbReception.Items.Objects[i] as TReception;
 MapFrame1.SelectRect(r.Rect);
end;

procedure TMainForm.acFlipperExecute(Sender: TObject);
var
 f:TFlipper;
begin
 if not MapFrame1.GetSelectionRect then begin
  ShowMessage('Vous devez slectionner une zone rectangulaire unique pour cette fonction.');
  exit;
 end;
 if FlipperProperties.Execute then begin
  f:=FlipperProperties.GetFlipper;
  f.Rect:=MapFrame1.Selection;
  lbFlipper.AddItem(Format('(%d,%d)-(%d,%d)',[f.Rect.Left,f.Rect.Top,f.Rect.Right,f.Rect.Bottom]),f);
 end;
end;

procedure TMainForm.lbFlipperClick(Sender: TObject);
var
 i:integer;
 f:TFlipper;
begin
 i:=lbFlipper.ItemIndex;
 if i<0 then exit;
 TabControl1.TabIndex:=1;
 Tabcontrol1Change(Self);
 f:=lbFlipper.Items.Objects[i] as TFlipper;
 MapFrame1.SelectRect(f.Rect);
end;

procedure TMainForm.lbFlipperDblClick(Sender: TObject);
var
 i:integer;
 f:TFlipper;
begin
 i:=lbFlipper.ItemIndex;
 if i<0 then exit;
 f:=lbFlipper.Items.Objects[i] as TFlipper;
 FlipperProperties.Edit(f);
end;

procedure TMainForm.CreeperTimerTimer(Sender: TObject);
begin
 MapFrame1.Invalidate;
end;

procedure TMainForm.acMergeLibAccept(Sender: TObject);
begin
 ImageTree1.Merge(acMergeLib.Dialog.FileName);
end;

procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 case Key of
  VK_DELETE: acListDel.Execute;
 end;
end;

end.
