unit ADKNETData;

{
 projet ADK-ISO/3D (c)2002 Paul TOTH <tothpaul@free.fr>

 http://www.web-synergy.net/naug-land/

 10 Janvier: Ajout de scText121
}
interface

uses
  HandBook2, Definitions;

const MaxTxtInfo = 255;

type

  TStr15 = string[15];

  TNegociate = packed record
    Server: TStr15; // Nom du serveur Ou IP du Client
    Version: word; // N de version du serveur ou Version du Client
    Banish: boolean; // Personnage banni ?
    Update: integer; // N d'UpDate Disponible sur le serveur (ou en cour chez le client).
  end;

  TServerInfo = packed record
    StartDate: TDateTime;
    SysDate: TDateTime;
    Influence: byte; // Zone d'influence
    ZoneTampon: byte; // Zone "tampon" au dela de la zone d'influence
    Speed: byte;
  end;

  TTextAttr = packed record
    Language: byte;
    Color: integer;
    Bold: boolean;
    Italic: boolean;
  end;

  TPlayerInfo = TPersonnage; // Definitions.pas

//uses Commandes;
type
  TServCmd = (scNull, // Rien.. Ne fait rien
    scNegociate, // Demande de Ngociation entre le connect et le serveur
    scSpecialDatas, // donn specifique au serveur envoy au client pour savoir  quoi s'en tenir (pas tres clair non ?)
    scInitFinish, // Initialisation terminer. Toute les donnes on t envoyer au Client pour pouvoir dmarrer le jeu
    scCloseConnect, // Ferme la conenxion
    scDisConnect, // Deconnecter le perso sans fermer la session
    scConnectMe, // demande de connexion "classique" au jeu
    scConnectMD, // demande de connexion en mode MD
    scNameExist, // Permet de savoir si un nom de personnage existe dja sur le serveur.
    scCreatePerso, // Demande de cration du personnage sur le serveur. Le serveur renvoie 0 si tout est Ok.. Sinon il renvoie un message d'erreur complet
    scPersoWrited, // Le perso  pu tre enregistrer dans la base de donnes. BoolToStr(true)= russi; BoolToStr(false)=Rat (Dans les deux cas il y a un string supplementaire. Soit avec l'erreur soit avec le nom du perso
    scCreatePerso2, // Demande de cration du personnage dans la BDE. le perso est envoyer sous forme d'un Record
    scUpdatePClient, // Envoie au client le perso au complet apres une demande de connexion par celui-ci.
    scActifItem, // Envoie au client tout les lments actif d'une carte (Donne envoy sous forme de stream)
    scMiniPersoDeco, // Deconnecter (supprim) le mini perso avec l'ID envoy

    scText, // Ecrit un text dans la zone de discution sans limite de distance
    scTextRp, // Ecrit un text dans la zone de discution.RP= Role play donc le texte n'est entendu que par ceux asser pret
    scTextServ, // Texte envoyer par le serveur
    scMDText, // Texte Entre MD
    scString, // Envoie un string simple sans Attributs
    scLoadmap, // Charge une carte

    scPlaceAt,  // Place le perso directement  la position indiquer mme si c'est dans un mur
    scTeleport, // Comme scPlaceAt mais verifie que l'emplacement et libre et en cherche un dans le cas contraire.
    scMoveTo,   // Le perso marche vers la direction indiqu (Ne pas oubli le Z)
    scRunTo,    // Le perso Cour vers la direction indiqu
    scJump,     // Le perso saute (visuellement) vers la position indiqu
    scEndMove,  // permet de placer un perso correctement sur sa tilde finale d'arrive.
    scStopmove, // permet d'arreter un perso  n'importe quel moment
    scRotate,   // Le perso "tourne" sur lui mme

    scPlayPersAnim, // Le perso avec le n d'ID indiqu joue l'anim indiqu
    scPlayFx, // Jou une anim FX
    scModifperso, // Appliquer la modif  la caract indiqu (Force, Dexterieter, Age, poids, inventaire etc)
    scAttaque, // Attaque le perso indiqu avec l'arme indiqu
    scLanceSort, // Lance le sort indiqu
    scOpenInventory, // Ouvre l'inventaire

    //Maintenance du serveur  distance
    scGetDefServer, // Renvoie le nom, le n de port et le protocol du serveur
    scChangeDefServer, // Change nom ou/et n de port ou/et le protocol
    scChangeVitesse, // Modifier la vitesse de dplacement par dfaut
    scChangeInfluence, // Modifier la taille du rayon d'influence
    scErasePerso, // Effacer personnage de la base de donnes
    scGetAllPerso, // Renvoie la dfinition de tous les perso
    scShutDown, // fait un shutDown du serveur
    scShutAndRun, // Fermer et redemarrer le serveur


    scStats, // Stats pour test uniquement (Voir dfinition Conditionelle: fasttest
    scPing, // Commande Ping (Just for test)

    // Commandes standards du jeu rajouter en sus
    scString21, // Texte sans attributs To One (D'un client  un client. On Utilise: TTextInfo21
    scText21, // Texte avec Attributs To One (D'un client  un client. On Utilise: TMessageInfo21
    scEchange, // Echange d'objets entre joueurs
    scGetActifItem, // Demande au serveur qu'il lui envoie l'actifItem avec l'ID qu'on lui envoie

    //Maintenance du serveur  distance (ajouter en sus)
    scPatchDispo, // Avertir de la disponibilit d'un nouveau Patch
    scChangeUrlUpdate, // Envoie un message contenant la nouvelle adresse (URL) ou se trouve le Patch
    scChangeUpdate, // Change le n d'update en cours sur le serveur
    scChangeVersionMiniClientAutorized, // Changer le numero de version minimal des clients que le serveur autorize  se connect
    scGetNbrPlayers, // Renvoie le nombre de joueurs connect
    scGetNbrSession, // Renvoie le nombre de session en cours
    scGetIdAllPlayer,// Renvoie les ID de tout les joueurs connects
    scShowMessage,   // Affiche un message dans la fnetre blanche d'information (Cette fenetre contient un TJvLinkLabel)
    scGetNameAndPass,// Renvoie tout les noms des perso avec le pass sou la forme Nom=pass
    scGetNbrIncrit,   // Renvoie le nombre de personnage enregistrer.

    scActifItemPNJ, // Comme scActifItem mais utilis exclusivement par les PNJ
    scChangeMap     // Le perso change de Map.    
    ); //Serveur commandes

  TLoginInfo = packed record
    name: TStr15;
    pass: TStr15;
    auth: boolean;
  end;

  TTextInfo = packed record
    size: integer;
    text: array[0..MaxTxtInfo] of char;
  end;

  TMessageInfo = packed record
    Attr: TTextAttr;
    Size: integer;
    text: array[0..1024] of char;
  end;

  TTextInfo21 = packed record
    IdDestinataire: Cardinal;
    size: integer;
    text: array[0..MaxTxtInfo] of char;
  end;

  TMessageInfo21 = packed record
    IdDestinataire: Cardinal;
    Attr: TTextAttr;
    Size: integer;
    text: array[0..1024] of char;
  end;

  TPositionInfo = packed record
    x, y, map: word;
    Vitesse: Shortint;
  end;

 (*
 // * * Record Li au objets actifs d'une carte * *
 TRecBaseActif= record
   ClassCardinal : Cardinal;
   Id            : Cardinal;
   Position      : TPositionInfo;
   visible       : byte;
 end;

 TRecNamedActif= record
   RecBaseActif: TRecBaseActif;
   Name: TStr15;
 end;


 // Dclaration pour TRecMiniPerso.

  TminiObjet= record
   IdObjet     :Word;         // N d'identification de l'objet
   Emplacement :Templacement; // Emplacement sur le perso (Main, tete, sac etc)
 end;

 TArrayMiniObjets= array[0..4] of TminiObjet;

 TRecMiniPerso= record
   RecNamedActif: TRecNamedActif;
   Race         : TRace;
   Sex          : TSex;
   ActiveSort   : array of TActiveSort;
   Objets       : TArrayMiniObjets;
   Moveto       : Tr_Pos;
   Running      : boolean;
 end;

*)
// Fin des Record Li au objets actifs d'une carte

  TBlockData = record
    case TServCmd of
      scNegociate: (Negociate: TNegociate);
      scSpecialDatas: (ServerInfo: TServerInfo);
      scConnectMe: (LoginInfo: TLoginInfo);
      scCloseConnect,
        scDisConnect,
        scLoadMap,
        scTextServ,
        scNameExist,
        scChangeUrlUpdate: (TextInfo: TTextInfo);
      scString21: (TextInfo21: TTextInfo21);
      scText21: (MessageInfo21: TMessageInfo21);
      scUpdatePClient,
        scCreatePerso2: (PlayerInfo: TPlayerInfo);
      scActifItem: (ActifItemInfo: Char);
      scText: (MessageInfo: TMessageInfo);
      scPing,
        scMiniPersoDeco,
        scChangeVitesse,
        scChangeInfluence,
        scErasePerso,
        scChangeVersionMiniClientAutorized,
        scChangeUpdate: (CardinalInfo: Cardinal);
      scPlaceAt,
        scTeleport,
        scMoveTo,
        scRunTo,
        scJump,
        scEndMove: (PositionInfo: TPositionInfo);
  end;

  TBlockHeader = packed record
    ID: Cardinal;
    Cmd: TServCmd;
  end;

  TBlock = packed record // Data doit tre "juste aprs" Head, or l'alignement par dfaut ne le fait pas.
    Head: TBlockHeader;
    Data: TBlockData;
  end;

  TADKBlock = packed record
    Size: integer;
    Head: TBlockHeader;
    Data: TBlockData;
  end;


implementation

end.

