unit ADKCreate9;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  jpeg, ExtCtrls, StdCtrls, CheckLst, HandBook, HandBook2, Players;

type
  TFrame9 = class(TFrame)
    Label1: TLabel;
    Bevel1: TBevel;
    lbLangue: TLabel;
    clbLangues: TCheckListBox;
    Image1: TImage;
    lbLangues: TLabel;
    lbCommun: TLabel;
    lbReserve: TLabel;
    procedure clbLanguesClickCheck(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    Reserve: integer;
    procedure ChoixLangues;
  end;

implementation

{$R *.dfm}

uses
  ADKCreate, Player;

function LangueParNom(nom: string): TLangue;
begin
  Result := Low(TLangue);
  while NomDesLangues[Result] <> nom do inc(Result);
end;

procedure TFrame9.ChoixLangues;
var
  l: TLangue;
  lr: TLangues;
  it: integer;
  s: string;
begin
  lbLangue.caption := 'Vous parlez couramment ' +
    NomDesLangues[LangueNatale[Character.Race]] +
    ' qui est votre langue natale.';
  clbLangues.Items.Clear;
  lr := LangagesParRace[Character.Race];
  it := High(IntelligenceAdjs);
  while IntelligenceAdjs[it].Score > Character.Scores[abIntelligence] do dec(it);
  Reserve := IntelligenceAdjs[it].Lang;
  if (lr = []) or (Reserve = 0) then begin
    lbLangues.Caption := 'Vous ne parlez aucune autre langue raciale,' +
      ' mais vous pourrez en apprendre plus tard, au cours du jeu.';
    clbLangues.Hide;
    lbReserve.Hide;
    lbCommun.Hide;
  end else begin
    s := IntToStr(Reserve) + ' autre langue';
    if Reserve > 1 then s := s + 's';
    lbLangues.Caption := 'Vous pouvez choisir ' + s + ' dans la liste ci-dessous.';
    lbCommun.Visible := (PARLER_COMMUN in lr);
    for l := Low(TLangue) to High(TLangue) do begin
      if l in lr then clbLangues.Items.Add(NomDesLangues[l]);
    end;
    clbLangues.Show;
    lbReserve.Caption := '';
    lbReserve.Show;
  end;
  Personnage.PointLangue:= reserve;
end;

procedure TFrame9.clbLanguesClickCheck(Sender: TObject);
var
  i: integer;
  s: string;
begin
  i := clbLangues.ItemIndex;
  if clbLangues.Checked[i] then begin
    if Reserve = 0 then begin
      clbLangues.Checked[i] := False;
      lbReserve.Caption := 'vous ne pouvez plus choisir d''autre langue';
      exit;
    end;
    dec(Reserve);
  end else begin
    inc(Reserve);
  end;
  if Reserve = 0 then s := '' else begin
    s := 'Il vous reste ' + IntToStr(Reserve) + ' langue';
    if Reserve > 1 then s := s + 's';
    s := s + '  choisir'
  end;
  lbReserve.Caption := s;
  Personnage.Langues := [];
  for i := 0 to clbLangues.Count - 1 do begin
    if clbLangues.Checked[i] then begin
      s := clbLangues.Items[i];
      Include(Personnage.Langues, LangueParNom(s));
    end;
  end;
  Personnage.PointLangue:= reserve;
end;

end.
