unit HandBook;

// le PHB (Player Handbook)

interface

Uses
 HandBook2;

Type
 TLangue =(
  PARLER_COMMUN,
  PARLER_ELFE, PARLER_GNOME, PARLER_HOBBIT, PARLER_NAIN,
  PARLER_GOBELIN, PARLER_HOBGOBELIN,
  PARLER_ORQUE, PARLER_GNOLL, PARLER_KOBOLD,
  PARLER_MAMIFERES_FOUISSEURS, PARLER_CREATURES_SOUTERRAINES
  );
 TLangues=set of TLangue;
{
Const // Nombre de Langues en fonction de l'Intelligence
 Langues:array[1..25] of byte=(0,1,1,1,1,1,1,1,2,2,2,3,3,4,4,5,6,7,8,9,10,11,12,15,20);
}
Const
 LangueNatale:array[TRace] of TLangue=(
  { HUMAIN          } PARLER_COMMUN,
  { ELFE            } PARLER_ELFE,
  { DEMI_ELFE       } PARLER_COMMUN,
  { GNOME           } PARLER_GNOME,
  { PETITE_PERSONNE } PARLER_HOBBIT,
  { NAIN            } PARLER_NAIN
 );
 LangagesParRace:array[TRace] of TLangues=(
  { HUMAIN          } [],
  { ELFE            } [PARLER_COMMUN,PARLER_GNOME,PARLER_HOBBIT,PARLER_GOBELIN,PARLER_HOBGOBELIN,PARLER_ORQUE,PARLER_GNOLL],
  { DEMI_ELFE       } [PARLER_ELFE,PARLER_GNOME,PARLER_HOBBIT,PARLER_GOBELIN,PARLER_HOBGOBELIN,PARLER_ORQUE,PARLER_GNOLL],
  { GNOME           } [PARLER_COMMUN,PARLER_NAIN,PARLER_HOBBIT,PARLER_GOBELIN,PARLER_KOBOLD,PARLER_MAMIFERES_FOUISSEURS],
  { PETITE_PERSONNE } [PARLER_COMMUN,PARLER_NAIN,PARLER_ELFE,PARLER_GNOME,PARLER_GOBELIN,PARLER_ORQUE],
  { NAIN            } [PARLER_COMMUN,PARLER_GNOME,PARLER_GOBELIN,PARLER_KOBOLD,PARLER_ORQUE,PARLER_CREATURES_SOUTERRAINES]
 );

 PointsDeVieParClasse:array[TClass] of byte=(
 // d de vie par classe
  10,10,10, 4, 8,8, 6,6
 );
 PointsDeVieConstitution:array[1..25] of shortint=(
 // maximum +2 pour les non-guerriers
  -3,-2,-2,-1,-1,-1,0,0,0,0,0,0,0,0,+1,+2,+3,+4,+5,+5,+6,+6,+6,+7,+7
 );

implementation


end.
