unit ADKObjects;

interface

type
 TADKObject=class
 protected
  fSort:boolean;
 public
  constructor Create;
  destructor Destroy; override;
  function BaseLine:integer; virtual; abstract;
  procedure Update(ms:cardinal); virtual; abstract;
  procedure Draw; virtual; abstract;
  function Light(lx,ly:single):integer; virtual;
 end;

implementation

uses
 ADKData;

constructor TADKObject.Create;
begin
 inherited;
 ObjectList.Add(Self);
end;

destructor TADKObject.Destroy;
begin
 ObjectList.Remove(Self);
 inherited;
end;

function TADKObject.Light(lx,ly:single):integer;
begin
 result:=0;
end;

end.
