unit ADKCreate8;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  jpeg, ExtCtrls, StdCtrls, CheckLst, HandBook, HandBook2, Players, Buttons;

type
  TFrame8 = class(TFrame)
    Label1: TLabel;
    Bevel1: TBevel;
    Image1: TImage;
    pbVoleur: TPaintBox;
    Bevel2: TBevel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton13: TSpeedButton;
    SpeedButton14: TSpeedButton;
    SpeedButton15: TSpeedButton;
    SpeedButton16: TSpeedButton;
    lbReserve: TLabel;
    Label2: TLabel;
    procedure pbVoleurPaint(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    reserve: integer;
    base: TThievingSkills;
    procedure CompetencesDeVoleur;
  end;

implementation

{$R *.dfm}

uses
  ADKCreate, Player;

procedure TFrame8.CompetencesDeVoleur;
var
  b: boolean;
  c: TThievingSkill;
  d: integer;
begin
  b := Bard in Character.Classes;
  for c := Low(TThievingSkill) to High(TThievingSkill) do begin
    Base[c] := ThievingSkillBaseScores[c, b] + ThievingSkillRacialAdjustements[Character.Race, c];
  end;
  d := 0;
  while ThievingSkillDexterityAdjustements[d].Score < Character.Scores[abDEXTERITY] do inc(d);
  for c := tsPickPockets to tsMoveSilently do begin
    inc(Base[c], ThievingSkillDexterityAdjustements[d].bonus[c]);
  end;
  Character.Thieving := Base;
  if Thief in Character.Classes then Reserve := 60 else Reserve := 20;
end;

procedure TFrame8.pbVoleurPaint(Sender: TObject);
var
  c: TThievingSkill;
  y, dy: integer;
  s: string;
  i: integer;
  b: integer;
begin
  with pbVoleur, Canvas do begin
    Brush.Color := clBlack;
    FillRect(Rect(Width - 30, 0, Width, Height));
    Brush.Style := bsClear;
    y := 0;
    dy := Height div 8;
    for c := Low(TThievingSkill) to High(TThievingSkill) do begin
      b := Base[c];
      if b >= 0 then Font.Color := clWhite else Font.Color := clGray;
      TextOut(0, y, ThievingSkillNames[c]);
      if b >= 0 then begin
        i := Character.Thieving[c];
        s := IntToStr(i) + '%';
        if i > Base[c] then Font.Color := clBlue else Font.Color := clWhite;
        TextOut(Width - TextWidth(s), y, s);
      end;
      inc(y, dy);
    end;
  end;
  case Reserve of
    0: lbReserve.Caption := 'plus de points';
    1: lbReserve.Caption := 'il reste 1 point';
  else lbReserve.Caption := 'il reste ' + IntToStr(Reserve) + ' points';
  end;
  Personnage.PointCompVoleurs:= Reserve;
end;

procedure TFrame8.SpeedButton1Click(Sender: TObject);
var
  c: TThievingSkill;
begin
  if Reserve = 0 then exit;
  c := TThievingSkill(TSpeedButton(Sender).Tag);
  if Base[c] < 0 then exit;
  if Character.Thieving[c] - Base[c] = 30 then exit; // max
  inc(Character.Thieving[c]);
  dec(Reserve);
  pbVoleurPaint(Self);
  Personnage.PointCompVoleurs:= Reserve;
end;

procedure TFrame8.SpeedButton2Click(Sender: TObject);
var
  c: TThievingSkill;
begin
  c := TThievingSkill(TSpeedButton(Sender).Tag);
  if Base[c] < 0 then exit;
  if Character.Thieving[c] = Base[c] then exit; // min
  dec(Character.Thieving[c]);
  inc(Reserve);
  pbVoleurPaint(Self);
  Personnage.PointCompVoleurs:= Reserve;
end;

end.
